//#include <ADuC7020.h>
#include <ioavr.h>
#include "AT45DB161_Def.h"

#define ENABLEFLASH     PORTB&=~(1<<6)
#define DISABLEFLASH    PORTB|=(1<<6) 
#define SPIF            7



void writespi (char dataspi) {
  /* Start transmission */
  SPDR = dataspi;
  /* Wait for transmission complete */
  while(!(SPSR & (1<<SPIF)));

}

char readspi(void) {
  SPDR = 0xFF;                        // write dummy value to start register shift
  while (!(SPSR & (1<<SPIF)));             // wait for data transfer to be completed

return SPDR;
}



char readflashstat(void) {
char stat;

  ENABLEFLASH;

  writespi(0xD7);

  stat = readspi();

  DISABLEFLASH;

return stat;
}

void eraseflash(void)
{
  ENABLEFLASH;
  writespi(0xC7);
  writespi(0x94);
  writespi(0x80);
  writespi(0x9A);
  DISABLEFLASH;
}

void writebuff(int nbuff, int adbuff, char databuff) { //    .
  // nbuff -  ,    .
  // adbuff -         
  // databuff - 
  
  ENABLEFLASH;

  writespi(nbuff);
  writespi(0x00);
  writespi(adbuff >> 8);
  writespi(adbuff);
  writespi(databuff);

  DISABLEFLASH;
}

void buff_to_page(int nbuff, int adpage) {

char statflag;

      ENABLEFLASH;

  writespi(nbuff);
  writespi(adpage >> 6);
  writespi(adpage << 2);
  writespi(0x00);

  DISABLEFLASH;

statflag = 0;
while (!(statflag & 0x80))
{statflag = readflashstat();}
  
}

char readpage(int adpage, int adbuff)
{

char dtpage;

  ENABLEFLASH;

  writespi(0xD2);
  writespi(adpage >> 6);
  writespi((adpage << 2) + (adbuff >> 8));
  writespi(adbuff);

  writespi(0x00);
  writespi(0x00);
  writespi(0x00);
  writespi(0x00);

  dtpage = readspi(); 

  DISABLEFLASH;
return dtpage;
}

void write_to_flash(int p, int b, int d) {

	writespi(0x85);
	writespi(p >> 6);
	writespi((p << 6)|(b >>8));
	writespi(b);
	writespi(d);
	}

