#ifndef __PRIVATE_BUS_H_
#define __PRIVATE_BUS_H_

#include "types.h"

#define MCU_SPEED								8
#define PRIVATE_BUS_SPEED_400					4
#define PRIVATE_BUS_SPEED_100					1

#define PRIVATE_BUS_SPEED	PRIVATE_BUS_SPEED_100	// speed of Software I2C (~kHz)

#if PRIVATE_BUS_SPEED == PRIVATE_BUS_SPEED_100		// definitions of Delays for 400kHz
	#define DELAY_CLK0								(((4.7-2.3) * MCU_SPEED)+1)
	#define DELAY_CLK1								(((4.0-1.9) * MCU_SPEED)+1)
	#define DELAY_START								((4.0 * MCU_SPEED)+1)
	#define DELAY_RESTART							((4.7 * MCU_SPEED)+1)
	#define DELAY_STOP								((4.0 * MCU_SPEED)+1)
	#define DELAY_STOP_START						((4.7 * MCU_SPEED)+1)
#endif

#if PRIVATE_BUS_SPEED == PRIVATE_BUS_SPEED_400		// definitions of Delays for 100kHz
	#define DELAY_CLK0								((1.3 * MCU_SPEED)+1)
	#define DELAY_CLK1								((0.6 * MCU_SPEED)+1)
	#define DELAY_START								((0.6 * MCU_SPEED)+1)
	#define DELAY_RESTART							((0.6 * MCU_SPEED)+1)
	#define DELAY_STOP								((0.6 * MCU_SPEED)+1)
	#define DELAY_STOP_START						((1.3 * MCU_SPEED)+1)
#endif

typedef struct {
	unsigned char BusID;
	unsigned char SDAT_SCLK_PINS;
	unsigned char *SDAT_PORT;
	unsigned char *SDAT_PINS;
	unsigned char *SDAT_DDR;
	unsigned char *SCLK_PORT;
	unsigned char *SCLK_PINS;
	unsigned char *SCLK_DDR;
} Private_Bus_Descriptor, *pPrivate_Bus_Descriptor;

typedef struct {
	unsigned char SCLK_Mask;
	unsigned char SDAT_Mask;
	unsigned char *SCLK_DDR;
	unsigned char *SDAT_DDR;
	unsigned char *SCLK_PINS;
	unsigned char *SDAT_PINS;
} Bus_Descriptor, *pBus_Descriptor;


extern unsigned char MasterWriteReadProc(
	unsigned char BusID, unsigned char I2CAddress,
	unsigned char WriteCount, unsigned char *WriteData,
	unsigned char ReadCount,  unsigned char *ReadData);

#endif     // #ifdef __PRIVATE_BUS_H_
