#include "Defines.h"
#include "Types.h"
#include <ioavr.h>
#include <intrinsics.h>

extern unsigned char Marker[BUFER_LENGTH+1];
extern Response      IO_Buffer[BUFER_LENGTH+1];
extern unsigned int Get_CRC16(unsigned char *puchMsg, unsigned char usDataLen);
extern void Response_through_USB(void *p);
extern unsigned char Emergency_message(unsigned char message);

void External_RAM_Init(void)
{
  XMCRB = 0;
  XMCRA = 0;
/*  
  PORTA = 0x00;
  DDRA  = 0xFF;
  
	XMCRB |= (1 << XMM1) | (1 << XMM2) | (1 << XMM0) ;  //Disable PC pins. | (1 << XMBK)
	XMCRA |= (1 << SRE) | (1 << SRW11) | (1 << SRW10);               // Adjustment of external memory: one sector, the minimal speed.
  */
}


unsigned char Write_To_Ext_Memory(unsigned char lay) {
  unsigned char i, ret=1;
  unsigned int /*w_temp_CRC,*/ w_address = 0;
  
  w_address = ((IO_Buffer[lay].Data[0] << 8) | IO_Buffer[lay].Data[1]); 
  
  if ((w_address + MEMORY_OFFSET + (IO_Buffer[lay].Length - 2)) <= 0xFFFF) {
		w_address += MEMORY_OFFSET; 
		
		for(i=2;i<IO_Buffer[lay].Length;i++) {
		                                      MEMORY_MAPPED_PORT( w_address ) = IO_Buffer[lay].Data[i];  
                                              w_address++;
		                                      }
		
		IO_Buffer[lay].Length = 1;
		IO_Buffer[lay].Data[0] = ALL_OK; 
		/*
		w_temp_CRC = Get_CRC16(&IO_Buffer[lay].Address, IO_Buffer[lay].Length);
		IO_Buffer[lay].CRC_H = (w_temp_CRC >> 8);
		IO_Buffer[lay].CRC_L = w_temp_CRC; */

  
  } else { 
			Emergency_message(INVALID_LENGTH); 
			ret=0;
		 }
  return ret;
}



unsigned char Read_From_Ext_Memory(unsigned char lay) {
  unsigned char len_temp, i, ret=1;
  unsigned int /*r_temp_CRC,*/ r_address = 0;
  
  r_address = ((IO_Buffer[lay].Data[0] << 8) | IO_Buffer[lay].Data[1]); 
  
  if ((r_address + MEMORY_OFFSET + (IO_Buffer[lay].Data[2])) <= 0xFFFF) {
	
		r_address += MEMORY_OFFSET; 
		len_temp = IO_Buffer[lay].Data[2]+2;
		
		for(i=2;i<len_temp;i++) {
		                         IO_Buffer[lay].Data[i] = MEMORY_MAPPED_PORT( r_address );
                                 r_address++;
		                         }
		IO_Buffer[lay].Length = len_temp;
		/*
		r_temp_CRC = Get_CRC16(&IO_Buffer[lay].Address, IO_Buffer[lay].Length);
		IO_Buffer[lay].CRC_H = (r_temp_CRC >> 8);
		IO_Buffer[lay].CRC_L = r_temp_CRC; */

  
  } else { 
			Emergency_message(INVALID_LENGTH); 
			ret=0;
  		 }
  return ret;
}

