
#include "conf\config.h"
#include "conf\conf_usb.h"
#include "cdc_task.h"
#include "..\..\lib_mcu\usb\usb_drv.h"
#include "usb_descriptors.h"
#include "..\..\modules\usb\device_chap9\usb_standard_request.h"
#include "usb_specific_request.h"
#include "..\..\..\common\lib_mcu\uart\uart_lib.h"


#include "uart_usb_lib.h"
#include <stdio.h>
#include "Defines.h"
#include "Types.h"
#include "TWI_slave.h"
 
#include "led.h"

#define ENABLE  1
#define DISABLE 0

#define FSS_LEN 64

#define EXTENSION_PERCENT 64

#define FILTER_MAX_LEN  8
#define NUM_OF_FILTERS  2

#define TEMP_BUF_LEN 20

#define AUTOMATIC_DELAY  10     //        ,   2.5 .
//#define AUTO_DEL         (1.22)*50*AUTOMATIC_DELAY


#if (TARGET_PLAT == PIROPILOT)
  #define MIN_LIM (1000-100)*2
  #define MAX_LIM (2000+100)*2
  #define PWM_LIM (0x9C3F)
  #define ZERO_POSITION (1500 * 2)
  #define DIV_FACTOR    (-5)
#else
  #define MIN_LIM (1000-100)
  #define MAX_LIM (2000+100)
  #define PWM_LIM (0x9C3F / 2)
  #define ZERO_POSITION (1500)
  #define DIV_FACTOR    (-10)
#endif


//_____ M A C R O S ________________________________________________________
#define TWO_CHANNELS 2
#define FOUR_CHANNELS 4 

#define NUM_OF_CHANNELS FOUR_CHANNELS

//_____ D E F I N I T I O N S ______________________________________________
 volatile unsigned char loss_signal_flag = 0; //    .
 volatile unsigned char loss_signal_limit = 0;
 volatile unsigned char manual_mode = 1;  //  -   
 unsigned char int_trigger = 0;

 volatile unsigned char CH1_flag = 0;
 volatile unsigned char CH2_flag = 0;
 
 volatile unsigned int  CH1_start_time = 0;
 volatile unsigned int  CH1_stop_time = 0;
 volatile unsigned int  CH2_start_time = 0;
 volatile unsigned int  CH2_stop_time = 0;

 unsigned char fix_CH1_flag = 0;
 unsigned char fix_CH2_flag = 0;
 
 unsigned int  buf_for_CH1_start_time = 0;
 unsigned int  buf_for_CH1_stop_time = 0;
 unsigned int  buf_for_CH2_start_time = 0;
 unsigned int  buf_for_CH2_stop_time = 0;
 
 unsigned int  measured_period_CH1 = 0;
 unsigned int  measured_period_CH2 = 0;
 
 unsigned int  CH1_MIN_input_PPM_period = 0xffff;
 unsigned int  CH1_MAX_input_PPM_period = 0; 
 unsigned int  CH2_MIN_input_PPM_period = 0xffff;
 unsigned int  CH2_MAX_input_PPM_period = 0;  
 
 unsigned int  CH1_Average_input_PPM_period = 0; 
 unsigned int  CH2_Average_input_PPM_period = 0; 
 
 //***************************
 #if (NUM_OF_CHANNELS == FOUR_CHANNELS) 
 
 volatile unsigned char CH3_flag = 0;
 volatile unsigned char CH4_flag = 0;
 
 volatile unsigned int  CH3_start_time = 0;
 volatile unsigned int  CH3_stop_time = 0;
 volatile unsigned int  CH4_start_time = 0;
 volatile unsigned int  CH4_stop_time = 0;

 unsigned char fix_CH3_flag = 0;
 unsigned char fix_CH4_flag = 0;
 
 unsigned int  buf_for_CH3_start_time = 0;
 unsigned int  buf_for_CH3_stop_time = 0;
 unsigned int  buf_for_CH4_start_time = 0;
 unsigned int  buf_for_CH4_stop_time = 0;
 
 unsigned int  measured_period_CH3 = 0;
 unsigned int  measured_period_CH4 = 0;
 
 unsigned int  CH3_MIN_input_PPM_period = 0xffff;
 unsigned int  CH3_MAX_input_PPM_period = 0; 
 unsigned int  CH4_MIN_input_PPM_period = 0xffff;
 unsigned int  CH4_MAX_input_PPM_period = 0;  
 
 unsigned int  CH3_Average_input_PPM_period = 0; 
 unsigned int  CH4_Average_input_PPM_period = 0; 
 
 #endif
 
int gaz = ZERO_POSITION;
int napr = ZERO_POSITION;     
int visota = ZERO_POSITION; 
int eleron = ZERO_POSITION; 


//_____ D E C L A R A T I O N S ____________________________________________

//Response temp_buf[7] = {'D',i,'k','o','y','+','+'};
volatile U8  cpt_sof;
extern U8    rx_counter;
extern U8    tx_counter;

unsigned char num_of_pirometers = 4;

unsigned char hwb_flag = 0;
unsigned int  write_counter = 0;
unsigned int  del_count = 0;
unsigned char record_start_flag = 0;
unsigned char is_flash_ready = 0;
unsigned char Measurement_start_flag = 0;

unsigned char size_of_FSS = 64;
//unsigned int servo_test = 500;

//         
unsigned int buffer_counter = 0;
//     
unsigned int page_counter = 0;  
//  
unsigned char number_of_buf = 1;
//    
//signed int zero_delta = 0;
signed int p1, p3, p2, p4;
float fZeroBank, fZeroPitch;

S_line_coding line_coding;
//extern unsigned char Get_Free_Layer(unsigned char offset);
//extern void Response_through_USB(void *p);
//extern unsigned int GetCrc16(unsigned char *buf, unsigned char len);
extern uchar USB_manager(void);
extern void markers_manager(void);
extern uchar TWI_manager(void);
extern void i2c_init(unsigned char my_addr);
extern unsigned char my_address;
extern void i2c_init_soft(void);

extern void erasing(void);
extern void SPI_state(unsigned char st);
extern unsigned char Is_DB642(void);
extern unsigned char read_flash_stat(void);

 signed int pitch_buf[FILTER_MAX_LEN+1][NUM_OF_FILTERS];
 signed int bank_buf[FILTER_MAX_LEN+1][NUM_OF_FILTERS]; 

extern void write_data_to_RAM_page(char *InputDataBuf, unsigned char DataLen, unsigned int StartAddr, char buffer_num);
extern void read_data_from_RAM_page(char *OutputDataBuf, unsigned char DataLen, unsigned int StartAddr, char buffer_num);
extern void RAM_buf_to_flash_page(unsigned int PageAddr, char buffer_num);
extern void flash_page_to_RAM_buf(unsigned int PageAddr, char buffer_num);

extern void DelayMs(unsigned short Ms);
extern Piro_IO Piro_Buf;
extern void read_pirometers(unsigned char cmd);

extern unsigned char Marker[BUFER_LENGTH+1];

float fTemp;

signed int bank_FSS_buf[FSS_LEN]; 
unsigned char bank_FSS_count = 0;


void Clear_of_filtered_value(void) {
  unsigned char i, j;

  for(i=0;i<FSS_LEN;i++) bank_FSS_buf[i] = 0;
                                                  
  for(j=0;j<NUM_OF_FILTERS;j++)  {                                                

    for(i=0;i<FILTER_MAX_LEN+1;i++) pitch_buf[i][j] = 0;
      
  }
  
  for(j=0;j<NUM_OF_FILTERS;j++)  {                                                

    for(i=0;i<FILTER_MAX_LEN+1;i++) bank_buf[i][j] = 0;
      
  }  
  
}


#pragma vector=0x5C
__interrupt void Timer0_ovf_isr(void) { //   0.
  
  if( int_trigger > loss_signal_limit ) {
    int_trigger = 0;
    if(manual_mode) loss_signal_flag++;
               else loss_signal_flag = 0;
  } else {
    int_trigger++; 
  }
}


#pragma vector=0x04
__interrupt void INT0_isr(void) { // .
  
  if( EICRA & (1<<0) ) { //    -  
    CH1_start_time = TCNT1;
    CH1_flag = 0;
    EICRA &= ~(1<<0); //   
  } else {
    CH1_stop_time = TCNT1;
    CH1_flag = 1;
    EICRA |= (1<<0); //   
    
        if(manual_mode) loss_signal_flag = 0;
                   else loss_signal_flag++;    
    
  }
}
 

#pragma vector=0x08
__interrupt void INT1_isr(void) { // .
  
  if( EICRA & (1<<2) ) { //    -  
    CH2_start_time = TCNT1;
    CH2_flag = 0;
    EICRA &= ~(1<<2); //   
  } else {
    CH2_stop_time = TCNT1;
    CH2_flag = 1;
    EICRA |= (1<<2); //   
  }
}


#if (NUM_OF_CHANNELS == FOUR_CHANNELS) 

#pragma vector=0x14
__interrupt void INT4_isr(void) {
 
  if( EICRB & (1<<0) ) { //    -  
    CH3_start_time = TCNT3;
    CH3_flag = 0;
    EICRB &= ~(1<<0); //   
  } else {
    CH3_stop_time = TCNT3;
    CH3_flag = 1;
    EICRB |= (1<<0); //   
  }
}
 
#pragma vector=0x18
__interrupt void INT5_isr(void) {
   
  if( EICRB & (1<<2) ) { //    -  
    CH4_start_time = TCNT3;
    CH4_flag = 0;
    EICRB &= ~(1<<2); //   
  } else {
    CH4_stop_time = TCNT3;
    CH4_flag = 1;
    EICRB |= (1<<2); //   
  }
}  

#endif

void init_hardware(void) {
  __disable_interrupt();
  
// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x05;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;
  // Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x01; //   
  
  //    
  PORTD &= ~((1<<0)|(1<<1));
  DDRD &= ~((1<<0)|(1<<1));
  PORTE &= ~((1<<5)|(1<<4));
  DDRE &= ~((1<<5)|(1<<4));
  
  
#if (NUM_OF_CHANNELS == TWO_CHANNELS)
    // External Interrupt(s) initialization
    // INT0: On
    // INT0 Mode: Rising Edge
    // INT1: On
    // INT1 Mode: Rising Edge
    // INT2: Off
    // INT3: Off
    // INT4: Off
    // INT5: Off
    // INT6: Off
    // INT7: Off
    EICRA=0x0F;
    EICRB=0x00;
    EIMSK=0x03;
    EIFR=0x03;
#else
    // External Interrupt(s) initialization
    // INT0: On
    // INT0 Mode: Rising Edge
    // INT1: On
    // INT1 Mode: Rising Edge
    // INT2: Off
    // INT3: Off
    // INT4: On
    // INT4 Mode: Rising Edge
    // INT5: On
    // INT5 Mode: Rising Edge
    // INT6: Off
    // INT7: Off
    EICRA=0x0F;
    EICRB=0x0F;
    EIMSK=0x33;
    EIFR=0x33;
#endif

//TIMER1 initialize
// desired value: 50Hz
        DDRB |= (1<<5)|(1<<6)|(1<<7); //    
        TCCR1B = 0;
        TCCR1A = 0;

	TCCR1B |= (1<<WGM12)|(1<<WGM13);  //bit_set(WGM12,WGM13);// Timer stopped, mode14     
	
	TCCR1A |= (1<<COM1A1)|(1<<COM1B1)|(1<<COM1C1)|(1<<WGM11);    // bit_set(COM1A1,COM1B1,COM1C1,WGM11); //noninverting fastPWM mode14 set
		
	ICR1= PWM_LIM; // 16 mhz 20000usec period,  8   2.     
	
	TCCR1B |= (1<<CS11);  //bit_set(CS11);  //Timer start with prescaler=8
        
        OCR1A = ZERO_POSITION;
        OCR1B = ZERO_POSITION;
        OCR1C = ZERO_POSITION;

//TIMER3 initialize
// desired value: 50Hz
        DDRC |= (1<<6)|(1<<5)|(1<<4); //    
        TCCR3B = 0;
        TCCR3A = 0;

	TCCR3B |= (1<<WGM12)|(1<<WGM13);  //bit_set(WGM12,WGM13);// Timer stopped, mode14     
	
	TCCR3A |= (1<<COM1A1)|(1<<COM1B1)|(1<<COM1C1)|(1<<WGM11);    // bit_set(COM1A1,COM1B1,COM1C1,WGM11); //noninverting fastPWM mode14 set
		
	ICR3= PWM_LIM; // 16 mhz 20000usec period,  8   2.     
	
	TCCR3B |= (1<<CS11);  //bit_set(CS11);  //Timer start with prescaler=8
        
        OCR3A = MIN_LIM;
        OCR3B = ZERO_POSITION;
        OCR3C = ZERO_POSITION;
        
    DDRC &= ~((1<<0)|(1<<1)|(1<<2)|(1<<3));  //   
    PORTC |= ((1<<0)|(1<<1)|(1<<2)|(1<<3));    //  DIP-  
        
__enable_interrupt();
}


void cdc_task_init(void) {
U8 j;

  Hwb_button_init();
  
  init_hardware();
	
	Clear_of_filtered_value();
	
	SPI_state(ENABLE);
    
        i2c_init_soft();
  
	for (j=0;j<BUFER_LENGTH;j++) { // Clearing of a array
		Marker[j] = FREE; 
	}
        
	__enable_interrupt();
  
	Usb_enable_sof_interrupt(); // SOFI INT enabled
}

void Calculation_of_corners(void) {
  
  //        fTemp = (Piro_Buf.Tobg_p1 - Piro_Buf.Tobg_p3)*4500.0;
        fTemp = (Piro_Buf.Tobg_p1 - Piro_Buf.Tobg_p3)*9000.0;        
        fTemp /= (p1-p3);
        fTemp += 0.5;
        Piro_Buf.degree_of_bank = fTemp;

//        fTemp = (Piro_Buf.Tobg_p2 - Piro_Buf.Tobg_p4)*4500.0;        
        fTemp = (Piro_Buf.Tobg_p2 - Piro_Buf.Tobg_p4)*9000.0;
        fTemp /= (p1-p3);
        fTemp += 0.5;        
        Piro_Buf.degree_of_pitch = fTemp;        
}


void Calculation_of_Turned_corners(void) {

        fTemp = ((Piro_Buf.Tobg_p1 - Piro_Buf.Tobg_p3)+(Piro_Buf.Tobg_p2 - Piro_Buf.Tobg_p4))*9000.0;        
        fTemp /= fZeroBank;
        fTemp += 0.5;
        Piro_Buf.degree_of_bank = fTemp;

        fTemp = (((Piro_Buf.Tobg_p1 - Piro_Buf.Tobg_p3)-(Piro_Buf.Tobg_p2 - Piro_Buf.Tobg_p4)))*9000.0;
        fTemp /= fZeroPitch;
        fTemp += 0.5;        
        Piro_Buf.degree_of_pitch = fTemp;
  Piro_Buf.zero_delta = fZeroPitch; //TEST
}



void Calculation_of_FSS_filtered_value(unsigned char size) {
    signed long temp0;
    unsigned char i;
  
    bank_FSS_buf[bank_FSS_count] = Piro_Buf.degree_of_bank;
    
    if( bank_FSS_count < size-1 )    bank_FSS_count++;
                     	        else bank_FSS_count = 0;
                                
    temp0 = 0;                                    
    for(i=0;i<size;i++) temp0 += bank_FSS_buf[i]; 
    
    Piro_Buf.degree_of_bank = (temp0 / size);
}


void Calculation_of_filtered_value(void) {
  signed long temp;
  unsigned char i, j;

pitch_buf[ pitch_buf[FILTER_MAX_LEN][0] ][0] = Piro_Buf.degree_of_pitch;

  if (pitch_buf[FILTER_MAX_LEN][0] < FILTER_MAX_LEN-1) pitch_buf[FILTER_MAX_LEN][0] ++;
                                                  else pitch_buf[FILTER_MAX_LEN][0] = 0;
                                                  
  for(j=0;j<NUM_OF_FILTERS;j++)  {                                                
    temp = 0;
      for(i=0;i<FILTER_MAX_LEN;i++) temp += pitch_buf[i][j];
      
    if(j >= NUM_OF_FILTERS-1) {
      Piro_Buf.degree_of_pitch = (temp / FILTER_MAX_LEN);
    } else {
      pitch_buf[ pitch_buf[FILTER_MAX_LEN][j+1] ][j+1] = (temp / FILTER_MAX_LEN);
    }
  }
  
  
bank_buf[ bank_buf[FILTER_MAX_LEN][0] ][0] = Piro_Buf.degree_of_bank;

  if (bank_buf[FILTER_MAX_LEN][0] < FILTER_MAX_LEN-1) bank_buf[FILTER_MAX_LEN][0] ++;
                                                 else bank_buf[FILTER_MAX_LEN][0] = 0;
                                                  
  for(j=0;j<NUM_OF_FILTERS;j++)  {                                                
    temp = 0;
      for(i=0;i<FILTER_MAX_LEN;i++) temp += bank_buf[i][j];
      
    if(j >= NUM_OF_FILTERS-1) {
      Piro_Buf.degree_of_bank = (temp / FILTER_MAX_LEN);
    } else {
      bank_buf[ bank_buf[FILTER_MAX_LEN][j+1] ][j+1] = (temp / FILTER_MAX_LEN);
    }
  }  
    
}


void set_FSS_size( void ) {

	size_of_FSS = 64;
	if( Piro_Buf.zero_delta < 50 ) { //      !
		while(1) {
			PORTD |=  0x80;
			BUSSER_ON;
			  DelayMs(200);
			PORTD &=  ~0x80;
			BUSSER_OFF;
			  DelayMs(200);		
		}
	}
	if( Piro_Buf.zero_delta > 100 )  size_of_FSS = 32; //  > 2 
	if( Piro_Buf.zero_delta > 500 )  size_of_FSS = 16; //  > 10 
	if( Piro_Buf.zero_delta > 1000 ) size_of_FSS = 8;  //  > 20 
}


void automatic_stabilization_process( void ) {
  
    visota = (CH1_Average_input_PPM_period + (Piro_Buf.degree_of_pitch / DIV_FACTOR ));  //    
      if (visota < MIN_LIM) visota = MIN_LIM;	else	if (visota > MAX_LIM)  visota = MAX_LIM;
      OCR1A = visota;
      
    eleron = (CH2_Average_input_PPM_period + (Piro_Buf.degree_of_bank / DIV_FACTOR ));   //      
      if (eleron < MIN_LIM) eleron = MIN_LIM;	else	if (eleron > MAX_LIM)  eleron = MAX_LIM;
      OCR1B = eleron;
      OCR1C = eleron; //mirror_value(eleron); 
}

 
unsigned int mirror_value(unsigned int val) {
  
  return (2*ZERO_POSITION - val);
}


void cdc_task(void) {
//  unsigned char interrupt_state_INTx;
  static unsigned char flash_count = 0;


//---   --------  
  __disable_interrupt();  
  if(CH1_flag) {
   buf_for_CH1_start_time = CH1_start_time; 
   buf_for_CH1_stop_time  = CH1_stop_time; 
   CH1_flag = 0;
   fix_CH1_flag = 0;
  }
  __enable_interrupt();   
  
   if( fix_CH1_flag == 0 ) { 
    if(buf_for_CH1_start_time < buf_for_CH1_stop_time) {    
      measured_period_CH1 = (buf_for_CH1_stop_time - buf_for_CH1_start_time);
    } else {
      measured_period_CH1 = (buf_for_CH1_stop_time + (PWM_LIM - buf_for_CH1_start_time));
    }
  fix_CH1_flag = 1;
  }
  
//---   --------     
  __disable_interrupt();  
  if(CH2_flag) {
   buf_for_CH2_start_time = CH2_start_time; 
   buf_for_CH2_stop_time  = CH2_stop_time; 
   CH2_flag = 0;
   fix_CH2_flag = 0;
  }
    __enable_interrupt();   
  
   if( fix_CH2_flag == 0 ) { 
    if(buf_for_CH2_start_time < buf_for_CH2_stop_time) {    
      measured_period_CH2 = (buf_for_CH2_stop_time - buf_for_CH2_start_time);
    } else {
      measured_period_CH2 = (buf_for_CH2_stop_time + (PWM_LIM - buf_for_CH2_start_time));
    }
  fix_CH2_flag = 1;
  }  
  
#if (NUM_OF_CHANNELS == FOUR_CHANNELS)    
//---   --------  
  __disable_interrupt();  
  if(CH3_flag) {
   buf_for_CH3_start_time = CH3_start_time; 
   buf_for_CH3_stop_time  = CH3_stop_time; 
   CH3_flag = 0;
   fix_CH3_flag = 0;
  }
  __enable_interrupt();   
  
   if( fix_CH3_flag == 0 ) { 
    if(buf_for_CH3_start_time < buf_for_CH3_stop_time) {    
      measured_period_CH3 = (buf_for_CH3_stop_time - buf_for_CH3_start_time);
    } else {
      measured_period_CH3 = (buf_for_CH3_stop_time + (PWM_LIM - buf_for_CH3_start_time));
    }
  fix_CH3_flag = 1;
  }
  
//---   --------   
  __disable_interrupt();  
  if(CH4_flag) {
   buf_for_CH4_start_time = CH4_start_time; 
   buf_for_CH4_stop_time  = CH4_stop_time; 
   CH4_flag = 0;
   fix_CH4_flag = 0;
  }
  __enable_interrupt();   
  
   if( fix_CH4_flag == 0 ) { 
    if(buf_for_CH4_start_time < buf_for_CH4_stop_time) {    
      measured_period_CH4 = (buf_for_CH4_stop_time - buf_for_CH4_start_time);
    } else {
      measured_period_CH4 = (buf_for_CH4_stop_time + (PWM_LIM - buf_for_CH4_start_time));
    }
  fix_CH4_flag = 1;
  }  
#endif
  //------------------------------------------------  
  
 
 // ------------------------------------------------------ 
  
  
if( Is_hwb() ) {
  
  if( DIP1_ON ) { //      ( 1   ON)
    if( Is_DB642() ) {
        while (!(read_flash_stat() & 0x80)); //   
	erasing();
        is_flash_ready = 1;
        PORTD |= GREEN_LED2;   // Green
    }
  }
     hwb_flag = 1;
     CH1_MIN_input_PPM_period = 0xffff;
     CH1_MAX_input_PPM_period = 0; 
     CH2_MIN_input_PPM_period = 0xffff;
     CH2_MAX_input_PPM_period = 0;  	
#if (NUM_OF_CHANNELS == FOUR_CHANNELS)      
     CH3_MIN_input_PPM_period = 0xffff;
     CH3_MAX_input_PPM_period = 0; 
     CH4_MIN_input_PPM_period = 0xffff;
     CH4_MAX_input_PPM_period = 0;  		     
#endif
    while( Is_hwb() );
}

if( hwb_flag ) { // 240 == 1 , 1  = 0,25 .
	
  if( (del_count < 1400) ) {
  
  if(del_count == 400) { //  10   
    read_pirometers( T_OBJ );
    BUSSER_ON;     
    fZeroBank = ((Piro_Buf.Tobg_p1 - Piro_Buf.Tobg_p3)+(Piro_Buf.Tobg_p2 - Piro_Buf.Tobg_p4));
    Piro_Buf.zero_delta = ((Piro_Buf.Tobg_p1 - Piro_Buf.Tobg_p3)+(Piro_Buf.Tobg_p2 - Piro_Buf.Tobg_p4));
//    set_FSS_size(); //     
  }
  
  if(del_count == 440) BUSSER_OFF; //  11   .
  
  if(del_count == 600) { //  15   
    read_pirometers( T_OBJ );
    BUSSER_ON;     
    fZeroPitch = (-((Piro_Buf.Tobg_p1 - Piro_Buf.Tobg_p3)-(Piro_Buf.Tobg_p2 - Piro_Buf.Tobg_p4)));
  }
  
  if(del_count == 640) BUSSER_OFF; //  16   .
    
  if((del_count == 1240) || (del_count == 1320)) BUSSER_ON;
  if((del_count == 1280) || (del_count == 1360)) BUSSER_OFF;
  
  del_count++;
  
  if(++flash_count > 10) {
	  PORTD ^= GREEN_LED1;   // Green
	  flash_count = 0;
  }
  
  //      
  if( (measured_period_CH1 > MIN_LIM) && (measured_period_CH1 < MAX_LIM) ) { //      
	  
		if( measured_period_CH1 < CH1_MIN_input_PPM_period ) CH1_MIN_input_PPM_period = measured_period_CH1; //  
		if( measured_period_CH1 > CH1_MAX_input_PPM_period ) CH1_MAX_input_PPM_period = measured_period_CH1; //  	  
		OCR1A = measured_period_CH1;
  }
  
  if( (measured_period_CH2 > MIN_LIM) && (measured_period_CH2 < MAX_LIM) ) { //      
	  
		if( measured_period_CH2 < CH2_MIN_input_PPM_period ) CH2_MIN_input_PPM_period = measured_period_CH2; //  
		if( measured_period_CH2 > CH2_MAX_input_PPM_period ) CH2_MAX_input_PPM_period = measured_period_CH2; //  
		OCR1B = measured_period_CH2;
		OCR1C = measured_period_CH2; //mirror_value(measured_period_CH2);
  }
#if (NUM_OF_CHANNELS == FOUR_CHANNELS)   
    //      
  if( (measured_period_CH3 > MIN_LIM) && (measured_period_CH3 < MAX_LIM) ) { //      
	  
		if( measured_period_CH3 < CH3_MIN_input_PPM_period ) CH3_MIN_input_PPM_period = measured_period_CH3; //  
		if( measured_period_CH3 > CH3_MAX_input_PPM_period ) CH3_MAX_input_PPM_period = measured_period_CH3; //  	  
		OCR3A = measured_period_CH3;
  }
  
  if( (measured_period_CH4 > MIN_LIM) && (measured_period_CH4 < MAX_LIM) ) { //      
	  
		if( measured_period_CH4 < CH4_MIN_input_PPM_period ) CH4_MIN_input_PPM_period = measured_period_CH4; //  
		if( measured_period_CH4 > CH4_MAX_input_PPM_period ) CH4_MAX_input_PPM_period = measured_period_CH4; //  
		OCR3B = measured_period_CH4;
  }
#endif  	
  DelayMs(25);
  
 } else {
			//    .
			CH1_Average_input_PPM_period = (CH1_MIN_input_PPM_period + CH1_MAX_input_PPM_period) / 2;
			CH2_Average_input_PPM_period = (CH2_MIN_input_PPM_period + CH2_MAX_input_PPM_period) / 2;
			
		    //      
	 		CH1_MIN_input_PPM_period -= (CH1_MIN_input_PPM_period / EXTENSION_PERCENT);
	 		CH1_MAX_input_PPM_period += (CH1_MAX_input_PPM_period / EXTENSION_PERCENT);
			
			CH2_MIN_input_PPM_period -= (CH2_MIN_input_PPM_period / EXTENSION_PERCENT);
			CH2_MAX_input_PPM_period += (CH2_MAX_input_PPM_period / EXTENSION_PERCENT);
				
		  	PORTD &= ~0x40; 
			//PORTD |=  0x80;
				
			del_count = 0;
			hwb_flag = 0;
			
			Measurement_start_flag = 1;
                        
                          if( (!(PINC & (1<<0))) && (is_flash_ready == 1)) { //      ( 1   ON)   
                                  record_start_flag = 1;
                          }
                  
			buffer_counter = 0;
			page_counter = 0;
		}
}   // end of if( (hwb_flag == 1))     
  



if(Measurement_start_flag) { //   
	
//-- ,    
    read_pirometers( T_OBJ ); //   
        
    Calculation_of_Turned_corners(); //  .
		
    Calculation_of_FSS_filtered_value( size_of_FSS ); //  .

 if( manual_mode )  {  //   , 

   if(loss_signal_flag > AUTOMATIC_DELAY) { //     AUTOMATIC_DELAY 
        loss_signal_flag = 0;
        manual_mode = 0; //  .
        loss_signal_limit = (AUTOMATIC_DELAY + (AUTOMATIC_DELAY/2));
   }
   
    //       ,  :
    if( (measured_period_CH1 > CH1_MIN_input_PPM_period) && (measured_period_CH1 < CH1_MAX_input_PPM_period) && 
        (measured_period_CH2 > CH2_MIN_input_PPM_period) && (measured_period_CH2 < CH2_MAX_input_PPM_period) ) {
        
         automatic_stabilization_process();    
          
     
        } else { //       : 
      
        if( (measured_period_CH1 > MIN_LIM) && (measured_period_CH1 < MAX_LIM) ) {
          OCR1A = (measured_period_CH1);
        }
        
        if( (measured_period_CH2 > MIN_LIM) && (measured_period_CH2 < MAX_LIM) ) {
          OCR1B = measured_period_CH2;
          OCR1C = measured_period_CH2; //mirror_value(measured_period_CH2);
        }
        
   }
#if (NUM_OF_CHANNELS == FOUR_CHANNELS)         
        
        if( (measured_period_CH3 > MIN_LIM) && (measured_period_CH3 < MAX_LIM) ) {
          OCR3A = (measured_period_CH3);
        }
        
        if( (measured_period_CH4 > MIN_LIM) && (measured_period_CH4 < MAX_LIM) ) {
          OCR3B = measured_period_CH4;
        } 
#endif         
    
 } else { //     , 
   if(loss_signal_flag > AUTOMATIC_DELAY) {
        loss_signal_flag = 0;
        loss_signal_limit = 0;        
        manual_mode = 1;
   }
   OCR3A = ZERO_POSITION; // 
   OCR3B = 1500; // 
   automatic_stabilization_process();    
 }
 

    
  PORTD ^=  0x10;
} else { //    ,   :

        if( (measured_period_CH1 > MIN_LIM) && (measured_period_CH1 < MAX_LIM) ) {
          OCR1A = (measured_period_CH1);
        }
        
        if( (measured_period_CH2 > MIN_LIM) && (measured_period_CH2 < MAX_LIM) ) {
          OCR1B = measured_period_CH2;
          OCR1C = measured_period_CH2; //mirror_value(measured_period_CH2);
        }
#if (NUM_OF_CHANNELS == FOUR_CHANNELS)         
        if( (measured_period_CH3 > MIN_LIM) && (measured_period_CH3 < MAX_LIM) ) {
          OCR3A = (measured_period_CH3);
        }
        
        if( (measured_period_CH4 > MIN_LIM) && (measured_period_CH4 < MAX_LIM) ) {
          OCR3B = measured_period_CH4;
        }        
#endif  
}
        
//--  ,    :
if(record_start_flag) {
  
	read_pirometers( T_A );
		
	if ( ( buffer_counter + (sizeof(Piro_Buf)) ) > 1055 ) { //   ...
	    //     .
            if (page_counter < 8192)  {          //    ...  
                            
                                    RAM_buf_to_flash_page(page_counter, number_of_buf);
                            
                                    if(number_of_buf == 1) number_of_buf = 2;
                                                      else number_of_buf = 1;
                                                      
                                    buffer_counter = 0;
                                    page_counter++;
                                    
                        	    write_data_to_RAM_page((char *)&Piro_Buf, sizeof(Piro_Buf), buffer_counter, number_of_buf);
                        	    buffer_counter += (sizeof(Piro_Buf));	                                    
                                    
                                    PORTD ^=  RED_LED1;
                                    
                    } else {        //   -  .
                                    PORTD &=  ~RED_LED1;
                                    PORTD &=  ~GREEN_LED2;
                                    record_start_flag = 0;
                                    is_flash_ready = 0;
                    }
		
	} else { //     ,   :
		write_data_to_RAM_page((char *)&Piro_Buf, sizeof(Piro_Buf), buffer_counter, number_of_buf);
		buffer_counter += (sizeof(Piro_Buf));              
	}
	
}

  
	//Enumeration processs OK ?
	if (Is_device_enumerated()) {
                PORTD |= GREEN_LED1; //LED_ON(GREEN_COLOR);
	
		// Is something received from the USB ?
		if (uart_usb_test_hit()) {
		 			  USB_manager();	
					  }
                markers_manager();
	} else {
		PORTD &= ~GREEN_LED1; //LED_OFF(GREEN_COLOR);
	}
	
	// The analysis of TWI.
        // TWI_manager();
	
	// The analysis of markers.
	//markers_manager();	
}

   
        
   



//! @brief sof_action
//!
//! This function increments the cpt_sof counter each times
//! the USB Start Of Frame interrupt subroutine is executed (1ms)
//! Usefull to manage time delays
//!
//! @warning Code:?? bytes (function code length)
//!
//! @param none
//!
//! @return none
void sof_action(void)
{
//   cpt_sof++;
 //  cpt_sof=0;
}

