#include "Defines.h"
#include "Types.h"
#include <ioavr.h>
#include <intrinsics.h>
#include "Private_I2C.h"
#include <string.h>
#include "led.h"


#define		MLX_calctemp(x)		x*2-27315

//         
extern unsigned int buffer_counter;
//     
extern unsigned int page_counter;  
//  
extern unsigned char number_of_buf;

//unsigned char Ta_flag = 1;
unsigned char read_start_flag = 1;

extern   unsigned char data1, data2, data3, data4;
extern   unsigned char num_of_pirometers;
/*
extern void write_to_flash(unsigned char flash_data);
extern void playback(void);
*/
extern char readspi(void);
extern void writespi (char dataspi);

extern unsigned int last_byte_page;
extern volatile unsigned char new_data;
//       
unsigned char dumb_data = 0; 
unsigned int ctr = 0;

extern void write_data_to_RAM_page(char *InputDataBuf, unsigned char DataLen, unsigned int StartAddr, char buffer_num);
extern void read_data_from_RAM_page(char *OutputDataBuf, unsigned char DataLen, unsigned int StartAddr, char buffer_num);
extern void RAM_buf_to_flash_page(unsigned int PageAddr, char buffer_num);
extern void flash_page_to_RAM_buf(unsigned int PageAddr, char buffer_num);
extern unsigned char read_flash_stat(void);

extern void i2c_init(unsigned char my_addr);
extern void i2c_start(void);
extern void i2c_stop(void);
extern void i2c_tx(unsigned char byte);
extern void i2c_tx_addr(unsigned char adr, unsigned char rw); // TEST!
extern unsigned char i2c_rx(unsigned char last_byte);
extern void i2c_SE_start_soft(void);

extern void i2c_init_soft(void);
extern void i2c_start_soft(void);
extern void i2c_stop_soft(void);
extern void i2c_tx_soft(unsigned char byte);
extern unsigned char i2c_rx_soft(unsigned char last_byte);

extern unsigned char Marker[BUFER_LENGTH+1];
extern Response      IO_Buffer[BUFER_LENGTH+1];
extern _Ext_I2C_Task_Data Ext_I2C_Task_Data;
unsigned char Emergency_message(unsigned char message);                             	
void DelayMs(unsigned short Ms);
unsigned char I2C_buf[MAX_EXT_I2C_LEN];
unsigned char I2C_buf_Length, I2C_buf_flag = 0;

Piro_IO Piro_Buf;




unsigned char Set_ATPWR_pins(unsigned char lay)
{
unsigned char temp, ret = 1;
  
	temp = IO_Buffer[lay].Data[0];
  
	if(temp & (1<<0)) PORTD |= (1<<2);
				else  PORTD &= ~(1<<2);
				
	if(temp & (1<<1)) PORTD |= (1<<3);
				else  PORTD &= ~(1<<3);
				
	if(temp & (1<<2)) PORTD |= (1<<4);
				else  PORTD &= ~(1<<4);
				
	if(temp & (1<<3)) PORTD |= (1<<5);
				else  PORTD &= ~(1<<5);

 return ret; 
}


unsigned char Set_FAN_Frequency(unsigned char lay)
{
unsigned char ret = 1;
	
	MEMORY_MAPPED_PORT( MEMORY_OFFSET + 0x10 ) = IO_Buffer[lay].Data[0];  
	
	IO_Buffer[lay].Data[0] = ALL_OK; 
	
	return ret; 
}

unsigned char Ext_I2C_Read(unsigned char lay)
{
  	// is chip address valid ?
	if (IO_Buffer[lay].Data[1] > 0x7F) {
		IO_Buffer[lay].Length = 1;
		IO_Buffer[lay].Data[0] = INVALID_TARGET;
		return 1;
	}                                             	
	
	// is length Length valid ?
	if ((IO_Buffer[lay].Data[2] > MAX_EXT_I2C_LEN) || (IO_Buffer[lay].Data[2] == 0)) {
		IO_Buffer[lay].Length = 1;
		IO_Buffer[lay].Data[0] = INVALID_LENGTH;
		return 1;
	}    
	
	// is bus id valid ?
	if (IO_Buffer[lay].Data[0] > 2) {
		IO_Buffer[lay].Length = 1;
		IO_Buffer[lay].Data[0] = INVALID_BUS_ID;
		return 1;
	}       
  
	// is task already active ?
	if (Ext_I2C_Task_Data.TaskActive == 1) {
		IO_Buffer[lay].Length = 1;
		IO_Buffer[lay].Data[0] = TASK_BUSY;
		return 1;
	}
	
	Ext_I2C_Task_Data.BusId = IO_Buffer[lay].Data[0]+1;
	Ext_I2C_Task_Data.ChipAddress = IO_Buffer[lay].Data[1];
	Ext_I2C_Task_Data.Length = IO_Buffer[lay].Data[2];
	Ext_I2C_Task_Data.Direction = READ_DIR;
	Ext_I2C_Task_Data.TaskActive = 1;
	
	IO_Buffer[lay].Length = 1;
	IO_Buffer[lay].Data[0] = ALL_OK;
	
	return 1; 
}

unsigned char Ext_I2C_Write(unsigned char lay)
{
  	// is chip address valid ?
	if (IO_Buffer[lay].Data[1] > 0x7F) {
		IO_Buffer[lay].Length = 1;
		IO_Buffer[lay].Data[0] = INVALID_TARGET;
		return 1;
	}                                             	
	
	// is length Length valid ?
	if ((IO_Buffer[lay].Length-2 > MAX_EXT_I2C_LEN) || (IO_Buffer[lay].Length == 0)) {
		IO_Buffer[lay].Length = 1;
		IO_Buffer[lay].Data[0] = INVALID_LENGTH;
		return 1;
	}  
	
		// is bus id valid ?
	if ((IO_Buffer[lay].Data[0] > 2)) {
		IO_Buffer[lay].Length = 1;
		IO_Buffer[lay].Data[0] = INVALID_BUS_ID;
		return 1;
	}                                             	
  
	// is task already active ?
	if (Ext_I2C_Task_Data.TaskActive == 1) {
		IO_Buffer[lay].Length = 1;
		IO_Buffer[lay].Data[0] = TASK_BUSY;
		return 1;
	}
	

	Ext_I2C_Task_Data.BusId = IO_Buffer[lay].Data[0]+1;
	Ext_I2C_Task_Data.ChipAddress = IO_Buffer[lay].Data[1];
	Ext_I2C_Task_Data.Length = IO_Buffer[lay].Length-2;
	memcpy(Ext_I2C_Task_Data.Data, IO_Buffer[lay].Data+2, Ext_I2C_Task_Data.Length);
	Ext_I2C_Task_Data.Direction = WRITE_DIR;
	Ext_I2C_Task_Data.TaskActive = 1;
	
	IO_Buffer[lay].Length = 1;
	IO_Buffer[lay].Data[0] = ALL_OK;
	
	return 1; 
}

unsigned char Ext_I2C_Result(unsigned char lay)
{
	if (Ext_I2C_Task_Data.TaskActive == 1) {
		IO_Buffer[lay].Length = 1;
		IO_Buffer[lay].Data[0] = TASK_BUSY;
		return 1;
	}
	
	IO_Buffer[lay].Length = 1;
	IO_Buffer[lay].Data[0] = Ext_I2C_Task_Data.Error;
	
	if (Ext_I2C_Task_Data.Direction == READ_DIR) {
		IO_Buffer[lay].Length += Ext_I2C_Task_Data.Length;
		memcpy(IO_Buffer[lay].Data+1, Ext_I2C_Task_Data.Data, Ext_I2C_Task_Data.Length);
	}
	
	return 1; 
}


unsigned char PEC_calculation(unsigned char pec[])
{
	unsigned char 	crc[6];
	unsigned char	BitPosition=47;
	unsigned char	shift;
	unsigned char	i;
	unsigned char	j;
	unsigned char	temp;

	do{
		crc[5]=0;				/* Load CRC value 0x000000000107 */
		crc[4]=0;
		crc[3]=0;
		crc[2]=0;
		crc[1]=0x01;
		crc[0]=0x07;
		BitPosition=47;			/* Set maximum bit position at 47 */
		shift=0;

		//Find first 1 in the transmited message
		i=5;					/* Set highest index */
		j=0;
		while((pec[i]&(0x80>>j))==0 && i>0){
			BitPosition--;
			if(j<7){
				j++;
			}
			else{
				j=0x00;
				i--;
			}
		}/*End of while */

		shift=BitPosition-8;	/*Get shift value for crc value*/


		//Shift crc value 
		while(shift){
			for(i=5; i<0xFF; i--){
				if((crc[i-1]&0x80) && (i>0)){
					temp=1;
				}
				else{
					temp=0;
				}
				crc[i]<<=1;
				crc[i]+=temp;
			}/*End of for*/
			shift--;
		}/*End of while*/


		//Exclusive OR between pec and crc		
		for(i=0; i<=5; i++){
			pec[i] ^=crc[i];
		}/*End of for*/
	}while(BitPosition>8);/*End of do-while*/

	return pec[0];
}/*End of PEC_calculation*/


void read_pirometers(unsigned char cmd) {
 
  	i2c_start_soft();
     
	  i2c_tx_soft(0);
 
	i2c_tx_soft(cmd);
	
	i2c_SE_start_soft();
	
	  i2c_tx_soft(0x01);
          
          if(cmd == T_OBJ) {
            
              Piro_Buf.Tobg_p1 = 0;
              Piro_Buf.Tobg_p2 = 0;
              Piro_Buf.Tobg_p3 = 0;
              Piro_Buf.Tobg_p4 = 0;            
            
            i2c_rx_soft(1);
              Piro_Buf.Tobg_p1 = data1;
              Piro_Buf.Tobg_p2 = data2;
              Piro_Buf.Tobg_p3 = data3;
              Piro_Buf.Tobg_p4 = data4;
            
            i2c_rx_soft(1);
              Piro_Buf.Tobg_p1 = ( (data1 << 8) | Piro_Buf.Tobg_p1);
              Piro_Buf.Tobg_p2 = ( (data2 << 8) | Piro_Buf.Tobg_p2);
              Piro_Buf.Tobg_p3 = ( (data3 << 8) | Piro_Buf.Tobg_p3);
              Piro_Buf.Tobg_p4 = ( (data4 << 8) | Piro_Buf.Tobg_p4);              
            
            i2c_rx_soft(0);
            
          } else { 
            
              Piro_Buf.Ta_p1 = 0;
              Piro_Buf.Ta_p2 = 0;
              Piro_Buf.Ta_p3 = 0;
              Piro_Buf.Ta_p4 = 0;            
            
            i2c_rx_soft(1);
              Piro_Buf.Ta_p1 = data1;
              Piro_Buf.Ta_p2 = data2;
              Piro_Buf.Ta_p3 = data3;
              Piro_Buf.Ta_p4 = data4;
            
            i2c_rx_soft(1);
              Piro_Buf.Ta_p1 = ( (data1 << 8) | Piro_Buf.Ta_p1);
              Piro_Buf.Ta_p2 = ( (data2 << 8) | Piro_Buf.Ta_p2);
              Piro_Buf.Ta_p3 = ( (data3 << 8) | Piro_Buf.Ta_p3);
              Piro_Buf.Ta_p4 = ( (data4 << 8) | Piro_Buf.Ta_p4); 
             
             i2c_rx_soft(0);
            
          }
          
          i2c_stop_soft();
}

unsigned char Ext_PIRO_Read(unsigned char lay)
{
/*unsigned char cmd, Thi, Tlo, Pec, PecReg;
  unsigned int temp;
  unsigned char arr[6];	
*/
  unsigned char cmd_temp;
  
  cmd_temp = IO_Buffer[lay].Data[0];
  
  
  if( DIP2_OFF ) { //      ( 2   OFF)
                      //    
  read_pirometers( cmd_temp );
  
    } else { //   2   ON,   :
    
       if( read_start_flag ) { //        
         read_start_flag = 0;
         
//********************************         
	if ( ( buffer_counter + (sizeof(Piro_Buf)) ) > 1055 ) { //   ...
	    //    .
            if (page_counter < 8192)  {          //    ...  
                            
                                    flash_page_to_RAM_buf(page_counter, number_of_buf);
                                    /*
                                    if(number_of_buf == 1) number_of_buf = 2;
                                                      else number_of_buf = 1;
                                    */              
                                    buffer_counter = 0;
                                    page_counter++;
                                    
                                    read_data_from_RAM_page((char *)&Piro_Buf, sizeof(Piro_Buf), buffer_counter, number_of_buf);
                                    buffer_counter += (sizeof(Piro_Buf));	                            

                    } else {        //   -  .
 
                                    while(1) {  
                                    PORTD ^=  0x80;
                                    DelayMs(500);
                                    }
                    }
		
	} else { //      ,   :
                 read_data_from_RAM_page((char *)&Piro_Buf, sizeof(Piro_Buf), buffer_counter, number_of_buf);
                 buffer_counter += (sizeof(Piro_Buf));	
	}         
//********************************         

       } else {
         read_start_flag = 1;
       }
    }
  
  
  
  
  if(cmd_temp == T_OBJ) {
  
    if(num_of_pirometers == 2) {
  
 	IO_Buffer[lay].Length = 4;

          IO_Buffer[lay].Data[0] = ((Piro_Buf.Tobg_p1 >> 8) & 0xff);
          IO_Buffer[lay].Data[1] = (Piro_Buf.Tobg_p1 & 0xff);
          
          IO_Buffer[lay].Data[2] = ((Piro_Buf.Tobg_p3 >> 8) & 0xff);
          IO_Buffer[lay].Data[3] = (Piro_Buf.Tobg_p3 & 0xff);
          
    } else { // if(num_of_pirometers == 4)
       	IO_Buffer[lay].Length = 8+4+2;

          IO_Buffer[lay].Data[0] = ((Piro_Buf.Tobg_p1 >> 8) & 0xff);
          IO_Buffer[lay].Data[1] = (Piro_Buf.Tobg_p1 & 0xff);
          
          IO_Buffer[lay].Data[2] = ((Piro_Buf.Tobg_p2 >> 8) & 0xff);
          IO_Buffer[lay].Data[3] = (Piro_Buf.Tobg_p2 & 0xff);
          
          IO_Buffer[lay].Data[4] = ((Piro_Buf.Tobg_p3 >> 8) & 0xff);
          IO_Buffer[lay].Data[5] = (Piro_Buf.Tobg_p3 & 0xff);
          
          IO_Buffer[lay].Data[6] = ((Piro_Buf.Tobg_p4 >> 8) & 0xff);
          IO_Buffer[lay].Data[7] = (Piro_Buf.Tobg_p4 & 0xff);
          
          IO_Buffer[lay].Data[8] = ((Piro_Buf.degree_of_bank >> 8) & 0xff);
          IO_Buffer[lay].Data[9] = (Piro_Buf.degree_of_bank & 0xff);

          IO_Buffer[lay].Data[10] = ((Piro_Buf.degree_of_pitch >> 8) & 0xff);
          IO_Buffer[lay].Data[11] = (Piro_Buf.degree_of_pitch & 0xff);     
          
          IO_Buffer[lay].Data[12] = ((Piro_Buf.zero_delta >> 8) & 0xff);
          IO_Buffer[lay].Data[13] = (Piro_Buf.zero_delta & 0xff);             
          
    }
          
  } else { // if(cmd_temp == T_A)
    
       if(num_of_pirometers == 2) {
  
 	IO_Buffer[lay].Length = 4;

          IO_Buffer[lay].Data[0] = ((Piro_Buf.Ta_p1 >> 8) & 0xff);
          IO_Buffer[lay].Data[1] = (Piro_Buf.Ta_p1 & 0xff);
          
          IO_Buffer[lay].Data[2] = ((Piro_Buf.Ta_p3 >> 8) & 0xff);
          IO_Buffer[lay].Data[3] = (Piro_Buf.Ta_p3 & 0xff);
          
    } else { // if(num_of_pirometers == 4)
       	IO_Buffer[lay].Length = 8+4+2;

          IO_Buffer[lay].Data[0] = ((Piro_Buf.Ta_p1 >> 8) & 0xff);
          IO_Buffer[lay].Data[1] = (Piro_Buf.Ta_p1 & 0xff);
          
          IO_Buffer[lay].Data[2] = ((Piro_Buf.Ta_p2 >> 8) & 0xff);
          IO_Buffer[lay].Data[3] = (Piro_Buf.Ta_p2 & 0xff);
          
          IO_Buffer[lay].Data[4] = ((Piro_Buf.Ta_p3 >> 8) & 0xff);
          IO_Buffer[lay].Data[5] = (Piro_Buf.Ta_p3 & 0xff);
          
          IO_Buffer[lay].Data[6] = ((Piro_Buf.Ta_p4 >> 8) & 0xff);
          IO_Buffer[lay].Data[7] = (Piro_Buf.Ta_p4 & 0xff);
          
          IO_Buffer[lay].Data[8] = ((Piro_Buf.degree_of_bank >> 8) & 0xff);
          IO_Buffer[lay].Data[9] = (Piro_Buf.degree_of_bank & 0xff);

          IO_Buffer[lay].Data[10] = ((Piro_Buf.degree_of_pitch >> 8) & 0xff);
          IO_Buffer[lay].Data[11] = (Piro_Buf.degree_of_pitch & 0xff);      
          
          IO_Buffer[lay].Data[12] = ((Piro_Buf.zero_delta >> 8) & 0xff);
          IO_Buffer[lay].Data[13] = (Piro_Buf.zero_delta & 0xff);   
          
    }
    
  }
    

  return 1;  
  
}


unsigned char Match_Test(unsigned char lay) { 
//  long a;
  
          Piro_Buf.Tobg_p1 = (((int)IO_Buffer[lay].Data[0]<<8) | IO_Buffer[lay].Data[1]);
          Piro_Buf.Tobg_p3 = (((int)IO_Buffer[lay].Data[2]<<8) | IO_Buffer[lay].Data[3]);
          Piro_Buf.Tobg_p2 = (((int)IO_Buffer[lay].Data[4]<<8) | IO_Buffer[lay].Data[5]);
          Piro_Buf.Tobg_p4 = (((int)IO_Buffer[lay].Data[6]<<8) | IO_Buffer[lay].Data[7]);          
 
  /*
          Piro_Buf.Tobg_p1 = -20;
          Piro_Buf.Tobg_p3 = -7;
          Piro_Buf.Tobg_p2 = 10;
          Piro_Buf.Tobg_p4 = 3;        
  */
//    Piro_Buf.degree_of_bank = (signed int)( ((Piro_Buf.Tobg_p2 - Piro_Buf.Tobg_p4) / (Piro_Buf.Tobg_p1 - Piro_Buf.Tobg_p3)) * 4500.0 );
          
//      Piro_Buf.degree_of_bank = (signed int)((((( (long)(Piro_Buf.Tobg_p2-Piro_Buf.Tobg_p4)*45000) ) / ( (long)(Piro_Buf.Tobg_p1-Piro_Buf.Tobg_p3)*45000 ))+5)/10);    

//         Piro_Buf.degree_of_bank = (( (signed long)(Piro_Buf.Tobg_p2 - Piro_Buf.Tobg_p4) * 4500 ) / ( Piro_Buf.Tobg_p1 - Piro_Buf.Tobg_p3));
    
         Piro_Buf.degree_of_bank = (Piro_Buf.Tobg_p2-Piro_Buf.Tobg_p4)*45/(Piro_Buf.Tobg_p1-Piro_Buf.Tobg_p3)*100;
          
       //   if(Piro_Buf.degree_of_bank == 1500) PORTD |= 0x40|0x80;

//Piro_Buf.degree_of_bank = (long)( (Piro_Buf.Tobg_p2-Piro_Buf.Tobg_p4) * 4500L ) / ( Piro_Buf.Tobg_p1-Piro_Buf.Tobg_p3);          

          IO_Buffer[lay].Data[0] = ((Piro_Buf.degree_of_bank >> 8) & 0xff);
          IO_Buffer[lay].Data[1] = (Piro_Buf.degree_of_bank & 0xff);
          IO_Buffer[lay].Data[2] = (sizeof(Piro_Buf));
          
//          IO_Buffer[lay].Data[0] = (Piro_Buf.Tobg_p2-Piro_Buf.Tobg_p4);
//          IO_Buffer[lay].Data[1] = (Piro_Buf.Tobg_p1-Piro_Buf.Tobg_p3);          
          

          IO_Buffer[lay].Length = 3;
return 1;
}


unsigned char Get_Flash_ID(unsigned char lay) { 
  
      SPCR = 0x5C; //  SPI
  
    PORTD |= 0x80; // 
    
 
	  DDRE |= (((1<<0) | (1<<1)));	
      PORTE &= ~(1<<0);
 
      
    IO_Buffer[lay].Length = 6;

      writespi(0x9F);
      IO_Buffer[lay].Data[0] = readspi();
      IO_Buffer[lay].Data[1] = readspi();
      IO_Buffer[lay].Data[2] = readspi();	  
      
	PORTE |= (1<<0);   
	PORTE &= ~(1<<1);
	
      writespi(0x9F);
      IO_Buffer[lay].Data[3] = readspi();
      IO_Buffer[lay].Data[4] = readspi();
      IO_Buffer[lay].Data[5] = readspi();	  
	
	PORTE |= (1<<1);   
    DDRE &= ~((1<<0) | (1<<1)); 
	
//  PORTB|= (1<<6); 
  PORTD &= ~0x80; //  
  SPCR = 0x00;

//  IO_Buffer[lay].Data[0] = 0x44;

return 1;
}


extern unsigned int  measured_period_CH1;
extern unsigned int  measured_period_CH2;

extern unsigned int  buf_for_CH1_start_time;
extern unsigned int  buf_for_CH1_stop_time;
extern unsigned int  buf_for_CH2_start_time;
extern unsigned int  buf_for_CH2_stop_time;


unsigned char Ext_Flash_Read(unsigned char lay) { 
 /*   char i, buf[20];
	char tbuf[20]  = {0,1,2,3,8,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19};
        
	
	write_data_to_RAM_page(&tbuf[0], 20, 0, 1);
	
	RAM_buf_to_flash_page(1, 1);
	
        flash_page_to_RAM_buf(1, 2);
	
	read_data_from_RAM_page(&buf[0], 20, 2, 2);
        
*/	
	IO_Buffer[lay].Data[0] = (measured_period_CH1 >> 8);
        IO_Buffer[lay].Data[1] = measured_period_CH1;
        
        IO_Buffer[lay].Data[2] = 0;        
        
	IO_Buffer[lay].Data[3] = (buf_for_CH1_start_time >> 8);
        IO_Buffer[lay].Data[4] = buf_for_CH1_start_time;        
	
        IO_Buffer[lay].Data[5] = 0;        
        
	IO_Buffer[lay].Data[6] = (buf_for_CH1_stop_time >> 8);
        IO_Buffer[lay].Data[7] = buf_for_CH1_stop_time;                
        
    IO_Buffer[lay].Length = 8;
	
  return 1;
}






