typedef struct  {
	unsigned char *VAL_PORT;
	unsigned char *DIR_PORT;
	unsigned char PORT_MASK;
} LED_Descriptor, *PLED_Descriptor;

#define MAX_LEDS	3

#if defined (__AT90USB1287__)
	#define LED_OFF(LedId)	{*(LEDs[LedId].VAL_PORT) &= ~LEDs[LedId].PORT_MASK;}
	#define LED_ON(LedId)	{*(LEDs[LedId].VAL_PORT) |= LEDs[LedId].PORT_MASK;}
#else
	#define LED_OFF(LedId)	{*(LEDs[LedId].VAL_PORT) |= LEDs[LedId].PORT_MASK;}
	#define LED_ON(LedId)	{*(LEDs[LedId].VAL_PORT) &= ~LEDs[LedId].PORT_MASK;}
#endif

#define GREEN_COLOR	0
#define YELLOW_COLOR    1
#define RED_COLOR       2
/*
#define Leds_init()		{*(LEDs[0].DIR_PORT)|=LEDs[0].PORT_MASK; *(LEDs[1].DIR_PORT)|=LEDs[1].PORT_MASK; *(LEDs[2].DIR_PORT)|=LEDs[2].PORT_MASK;}
#define Leds_on()		{LED_ON(0); LED_ON(1); LED_ON(2);}
#define Leds_off()		{LED_OFF(0); LED_OFF(1); LED_OFF(2);}
*/

#define Leds_init() DDRD |= 0xf0
#define Leds_on()   PORTD |= 0xf0
#define Leds_off()  PORTD &= ~0xf0

#define GREEN_LED1 (1<<5)
#define GREEN_LED2 (1<<6)
#define RED_LED1   (1<<7)
#define RED_LED2   (1<<4)

extern LED_Descriptor LEDs[MAX_LEDS];
