
//_____  I N C L U D E S ___________________________________________________

#include <string.h>

#include "conf\config.h"
#include "..\..\..\common\modules\scheduler\scheduler.h"
#include "..\..\..\common\lib_mcu\wdt\wdt_drv.h"
#include "..\..\lib_mcu\power\power_drv.h"
#include "Defines.h"

#include "Private_I2C.h"

#include "led.h"
#include "twi.h"

//_____ M A C R O S ________________________________________________________

//_____ D E F I N I T I O N S ______________________________________________

// extern int uart_usb_putchar(int data_to_send);  
// extern void uart_usb_flush (void);

unsigned char my_address, i;
_Ext_I2C_Task_Data Ext_I2C_Task_Data;

void DelayMs(unsigned short Ms);
extern void External_RAM_Init(void);
extern void ADC_init(void);
extern unsigned int read_adc(unsigned char adc_input);

unsigned char Process_TWI(void);
unsigned char twi_init(unsigned char my_addr);
unsigned char twi_start(void);
unsigned char twi_stop(void);
unsigned char twi_tx(unsigned char byte);
unsigned char twi_tx_addr(unsigned char adr, unsigned char rw);
unsigned char twi_rx(unsigned char *data_byte, unsigned char last_byte);
unsigned char twi_error;
static unsigned char twi_delay(void);
uint rit = 0;


#define TWI_STATUS					(TWSR & 0xF8)
#define TWI_OK					0x00	// All is OK
#define TWI_BUS_ERROR			0xFF	//bus is not 1:1 state



#define TWI_START				0x08	//START has been transmitted
#define TWI_RESTART				0x10	//Repeated START has been transmitted
#define TWI_MTX_ADR_ACK			0x18	//SLA+W has been tramsmitted and ACK received
#define TWI_MRX_ADR_ACK			0x40	//SLA+R has been tramsmitted and ACK received
#define TWI_MTX_DATA_ACK		0x28	//Data byte has been tramsmitted and ACK received
#define TWI_MRX_DATA_ACK		0x50	//Data byte has been received and ACK tramsmitted
#define TWI_MRX_DATA_NACK		0x58	//Data byte has been received and NACK tramsmitted


void usb_task(void);

void Eeprom_Task_Init(void);
void Eeprom_Task_Run(void);

int main(void)
{

	__disable_interrupt(); // Watchdog enable
	__watchdog_reset();
    WDTCSR = (1 << WDCE) | (1<<WDE);
    WDTCSR = (1 << WDE) | (1 << WDP2) | (1 << WDP1) | (1 << WDP0);
	__enable_interrupt();
	
	Clear_prescaler();
	
	Leds_init();
	Leds_off();
        
        BUSSER_OFF;        //   
        DDRF  |= (1<<0);


	for (i=0; i<2; i++) {
		Leds_on();
                BUSSER_ON;
		DelayMs(250);
		Leds_off();
                BUSSER_OFF;
		DelayMs(250);
	}
	

	DelayMs(500); // delay for usb 
	my_address = 0x01; 

	
	usb_task_init();
	cdc_task_init();  
//	Eeprom_Task_Init();
	
	for(;;) {
/*          
                if(++rit >= 20000) {
                  PORTD ^= RED_LED2;   // 
                  rit = 0;
                }
*/          
		__watchdog_reset();
		usb_task();
		cdc_task();
//		Eeprom_Task_Run();
	}
}

void DelayMs(unsigned short Ms)
{
unsigned char j;

	for (unsigned short i = 0; i < Ms; i++) {
		for (j = 0; j < 10*K_FOSC; j++) {      
			__watchdog_reset();
			__delay_cycles(800); // 100 us on 8 MHz
		}
	}
}

void Eeprom_Task_Init(void)
{
	Ext_I2C_Task_Data.TaskActive = 0;
	Ext_I2C_Task_Data.Direction = WRITE_DIR;
	Ext_I2C_Task_Data.Error = ALL_OK;
}

void Eeprom_Task_Run(void)
{
unsigned char interrupt_state;
	
	if (Ext_I2C_Task_Data.TaskActive == 0) return;
	Ext_I2C_Task_Data.TaskActive = 0;

	if (Ext_I2C_Task_Data.BusId != 1) {
		interrupt_state = __save_interrupt();
		__disable_interrupt();
		if (Ext_I2C_Task_Data.Direction == READ_DIR) { // read
			Ext_I2C_Task_Data.Error = 
				MasterWriteReadProc(Ext_I2C_Task_Data.BusId, Ext_I2C_Task_Data.ChipAddress<<1, 0, Ext_I2C_Task_Data.Data, Ext_I2C_Task_Data.Length, Ext_I2C_Task_Data.Data);
		} else { // write
			Ext_I2C_Task_Data.Error = 
				MasterWriteReadProc(Ext_I2C_Task_Data.BusId, Ext_I2C_Task_Data.ChipAddress<<1, Ext_I2C_Task_Data.Length, Ext_I2C_Task_Data.Data, 0, 0);
		}
		__restore_interrupt(interrupt_state);
	} else {
		Ext_I2C_Task_Data.Error = Process_TWI();
	}
}

unsigned char Process_TWI(void)
{
unsigned char error, i, last_byte;
	
	// Start
	error = twi_start();
	if (error != TWI_OK) {twi_stop(); return error;}
	
	if (Ext_I2C_Task_Data.Direction == READ_DIR) {
		// Send address
		error = twi_tx_addr((0x7F & Ext_I2C_Task_Data.ChipAddress), 'R');
		if (error != TWI_OK) {twi_stop(); return error;}
		
		// Read data
		for (i = 0; i < Ext_I2C_Task_Data.Length; i++) {
			last_byte = (i == (Ext_I2C_Task_Data.Length-1)) ? 1 : 0;
			error = twi_rx(&(Ext_I2C_Task_Data.Data[i]), last_byte);
			if (error != TWI_OK) {twi_stop(); return error;}
		}
	} else {
		// Send address
		error = twi_tx_addr((0x7F & Ext_I2C_Task_Data.ChipAddress), 'W');
		if (error != TWI_OK) {twi_stop(); return error;}
		
		// Write data
		for (i = 0; i < Ext_I2C_Task_Data.Length; i++) {
			error = twi_tx(Ext_I2C_Task_Data.Data[i]);
			if (error != TWI_OK) {twi_stop(); return error;}
		}
	}
	
	// Send stop
	twi_stop();
	return TWI_OK;
}

unsigned char twi_init(unsigned char my_addr)
{
	TWCR = 0;
	
	I2CPORT |= (1<<I2CCLOCK)|(1<<I2CDATA);
	I2CDDR &= ~((1<<I2CCLOCK)|(1<<I2CDATA));
	
	TWSR = 0;
	TWDR = 0xFF;
	TWAR = ((my_addr<<1) | 0x01);			// enable geberal requests
	TWAMR = 0;								// disable masks
	TWBR = TWI_CLOCK_REGISTER_SETUP;
	TWCR = (1<<TWEN) | (1<<TWEA);			// enable TWI
	twi_error = TWI_OK;						// clear errors
	
	return twi_error;
}

unsigned char twi_start(void)
{
	TWCR = (1<<TWEN) | (1<<TWINT) | (1<<TWSTA) | (1<<TWEA); // Send start condition
	
	twi_delay();
	
	// Check Start condition
	if ((TWI_STATUS == TWI_START) || (TWI_STATUS == TWI_RESTART))	twi_error = TWI_OK;
	else															twi_error = TWI_STATUS;
	
	return twi_error;
}

unsigned char twi_stop(void)
{
	TWCR = (1<<TWEN) | (1<<TWINT) | (1<<TWSTO); // Send stop condition
	return TWI_OK;
}

unsigned char twi_tx_addr(unsigned char addr, unsigned char dir)
{
	if (dir == 'W')	TWDR = ((addr<<1) & 0xFE);	// Set LSB bit to 0 for "write"
	else			TWDR = ((addr<<1) | 0x01);	// Set LSB bit to 1 for "read"
	
	TWCR = (1<<TWINT) | (1<<TWEN);	// Clear int flag to send byte
	
	twi_delay();
	
	if (dir == 'W') {
		if (TWI_STATUS == TWI_MTX_ADR_ACK)	twi_error = TWI_OK;
		else								twi_error = TWI_STATUS;
	} else {
		if (TWI_STATUS == TWI_MRX_ADR_ACK)	twi_error = TWI_OK;
		else								twi_error = TWI_STATUS;
	}
	
	return twi_error;
}

unsigned char twi_tx(unsigned char byte)
{
	TWDR = byte;
	TWCR = (1<<TWINT) | (1<<TWEN);
	
	twi_delay();
	
	if (TWI_STATUS == TWI_MTX_DATA_ACK)	twi_error = TWI_OK;
	else								twi_error = TWI_STATUS;
	
	return twi_error;
}

unsigned char twi_rx(unsigned char *data_byte, unsigned char last_byte)
{
	if (last_byte)	TWCR = (1<<TWINT) | (1<<TWEN);
	else			TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWEA);
	
	twi_delay();
	
	if (last_byte) {
		if (TWI_STATUS == TWI_MRX_DATA_NACK)	twi_error = TWI_OK;
		else									twi_error = TWI_STATUS;
	} else {
		if (TWI_STATUS == TWI_MRX_DATA_ACK)		twi_error = TWI_OK;
		else									twi_error = TWI_STATUS;
	}
	
	*data_byte = TWDR;
	return twi_error;
}

static unsigned char twi_delay(void)
{
	while (!(TWCR & (1<<TWINT)));
	return TWI_OK;
}
