/*******************************************************************************************
*    I2C                                                        *
                                                        *
*******************************************************************************************/

#include "twi.h"
//#include <Types.h>
#include "led.h"

  unsigned char data1, data2, data3, data4;

unsigned char i2c_error;                              // >0,       I2C
unsigned char i2c1_error_soft, i2c2_error_soft;       // ,   
extern unsigned char my_address;

unsigned char i2c_error_soft;                         // ,   

//   I2C
void i2c_init_soft(void)
{
  I2C_DDR &= ~( 1<<SDA1_LN );        //  SDA
  I2C_DDR &= ~( 1<<SDA2_LN );
  I2C_DDR &= ~( 1<<SDA3_LN );
  I2C_DDR &= ~( 1<<SDA4_LN );
  I2C_DDR &= ~( 1<<SCL_LN  );      	// SCL   
  
  I2C_PORT &= ~( 1<<SDA1_LN );       //       
  I2C_PORT &= ~( 1<<SDA2_LN ); 
  I2C_PORT &= ~( 1<<SDA3_LN ); 
  I2C_PORT &= ~( 1<<SDA4_LN ); 
  I2C_PORT &= ~( 1<<SCL_LN  );                            				// 
  
  i2c_error_soft=0;                                   				//   :-)
}

//  ""
void i2c_start_soft(void)
{
  if(i2c_error_soft)
    return;
  scl_set(1);
  sda_set(0);
  scl_set(0);
}

void i2c_SE_start_soft(void)
{
  if(i2c_error_soft)  return;
  
  sda_set(1);
  scl_set(1);
  sda_set(0);
  scl_set(0);
}

//  ""
void i2c_stop_soft(void)
{
  sda_set(0);
  scl_set(1);
  sda_set(1);
  if(i2c_error_soft)
    i2c_init_soft();
}

// 
void i2c_tx_soft(unsigned char byte)
{
  unsigned char i;
  if(i2c_error_soft) return;
  
  for(i=0;i<8;i++)
    {
      if(byte&0x80) sda_set(1);
               else sda_set(0);
      scl_set(1);
      scl_set(0);
      byte<<=1;
    }
  sda_io(IN_LN);
  scl_set(1);
 //  __delay_cycles(I2C_T*F_CLK); // TEST!!!
//  i2c_error_soft=in_sda();
//  if(i2c_error_soft) LED_ON(YELLOW_COLOR); //TEST!!!
  scl_set(0);
  sda_io(OUT_LN);
}


// ,  last_byte=0,          
unsigned char i2c_rx_soft(unsigned char last_byte)
{
//  unsigned char data=0;
  unsigned char mask=0x80;
  data1 = 0;
  data2 = 0;
  data3 = 0;
  data4 = 0;
  
  if(i2c_error_soft)
    return 0;
  sda_io(IN_LN);
  for(unsigned char i=0;i<8;i++)
    {
      scl_set(1);
      
      if(in_sda(1))  data1 = data1 + mask;
      if(in_sda(2))  data2 = data2 + mask;      
      if(in_sda(3))  data3 = data3 + mask;
      if(in_sda(4))  data4 = data4 + mask;
      
      mask>>=1;
      scl_set(0);
    }
  sda_io(OUT_LN);
  if(last_byte)
    sda_set(0);
  else
    sda_set(1);
  scl_set(1);
  scl_set(0);
  
  
  
  return 1;
}

//   SDA
unsigned char in_sda(unsigned char num)
{
   switch (num) {
    case 1:
      num = (1<<SDA1_LN);
    break;
       
    case 2:
      num = (1<<SDA2_LN);      
    break;
    
    case 3:
      num = (1<<SDA3_LN);      
    break;
    
    case 4:
      num = (1<<SDA4_LN);      
    break;                 
    }
   
  if( I2C_PIN & num )
    return 1;
  else
    return 0;
}

//  SDA    
void sda_io(unsigned char io_c)
{
  if(io_c==IN_LN) {
    I2C_DDR &= ~( 1<<SDA1_LN );        
    I2C_DDR &= ~( 1<<SDA2_LN );
    I2C_DDR &= ~( 1<<SDA3_LN );
    I2C_DDR &= ~( 1<<SDA4_LN );
  }  else {
    I2C_DDR |= ( 1<<SDA1_LN );   
    I2C_DDR |= ( 1<<SDA2_LN );
    I2C_DDR |= ( 1<<SDA3_LN );
    I2C_DDR |= ( 1<<SDA4_LN ); 
  }
  __delay_cycles(I2C_T*F_CLK);
}

//    SCL
void scl_set(unsigned char set_c)
{
  if(set_c)
    {
      I2C_DDR&=~(1<<SCL_LN);
      I2C_PORT&=~(1<<SCL_LN);
    }
  else
    {
      I2C_DDR|=(1<<SCL_LN);
      I2C_PORT&=~(1<<SCL_LN);
    }
  __delay_cycles(I2C_T*F_CLK);
}

//    SDA
void sda_set(unsigned char set_c)
{
  if(set_c)
    {
  I2C_DDR &= ~( 1<<SDA1_LN );        //  SDA
  I2C_DDR &= ~( 1<<SDA2_LN );
  I2C_DDR &= ~( 1<<SDA3_LN );
  I2C_DDR &= ~( 1<<SDA4_LN );
  
  I2C_PORT &= ~( 1<<SDA1_LN );       
  I2C_PORT &= ~( 1<<SDA2_LN ); 
  I2C_PORT &= ~( 1<<SDA3_LN ); 
  I2C_PORT &= ~( 1<<SDA4_LN ); 
    }
  else
    {
    I2C_DDR |= ( 1<<SDA1_LN );   
    I2C_DDR |= ( 1<<SDA2_LN );
    I2C_DDR |= ( 1<<SDA3_LN );
    I2C_DDR |= ( 1<<SDA4_LN ); 
    
  I2C_PORT &= ~( 1<<SDA1_LN );       
  I2C_PORT &= ~( 1<<SDA2_LN ); 
  I2C_PORT &= ~( 1<<SDA3_LN ); 
  I2C_PORT &= ~( 1<<SDA4_LN ); 
    }
  __delay_cycles(I2C_T*F_CLK);
}



//----------------------------------------------------------------------------------------------------
//   I2C
void i2c_init(unsigned char my_addr)
{
  TWCR = 0;
  
     I2CPORT |= (1<<I2CCLOCK)|(1<<I2CDATA);
     I2CDDR &= ~((1<<I2CCLOCK)|(1<<I2CDATA));
   
  TWSR=0;
  TWDR=0xFF;
  TWAR = ((my_addr<<1) | 0x01); //Set LSB bit to 1;
  TWAMR = 0;  //    
  TWBR = TWI_TWBR;                                    //   i2c
  TWCR = ((1<<TWEN)|(1<<TWEA));                         //  i2c
  i2c_error=0;                                        //  
}

//  ""
void i2c_start(void)
{
//  if(i2c_error) return;
  
  TWCR=((1<<TWEN)|(1<<TWINT)|(1<<TWSTA)|(1<<TWEA));
  i2c_delay();
  if((TWSR != START)&&(TWSR != REP_START))            //     
    i2c_error=1;                                      //  
}

//  ""
void i2c_stop(void)
{
  TWCR = ((1<<TWEN)|(1<<TWINT)|(1<<TWSTO));
 // if(i2c_error)
    i2c_init(my_address);
}

// 
void i2c_tx(unsigned char byte)
{
//  if(i2c_error)  return;
  
  i2c_delay();
  TWDR = byte;
  TWCR = ((1<<TWINT)|(1<<TWEN)|(1<<TWEA));
 // i2c_delay();
  while  (!(TWCR&(1<<TWINT)));
  if(TWSR != MTX_DATA_ACK) (PORTD |= 0x40); //Led2_on();                          //    , 
  //  i2c_error=1;                                      // 
//   TWCR = 0;
//   TWSR = 0;
 //  TWDR = 0xFF;
}

//   + RW/RD
void i2c_tx_addr(unsigned char adr, unsigned char rw)
{
  i2c_delay();   //Wait for TWI interrupt flag set
  
  if (rw == 'W')  TWDR = ((adr<<1) & 0xFE); //Set LSB bit to 0 for "write"
     else         TWDR = ((adr<<1) | 0x01); //Set LSB bit to 1 for "read"
	
  TWCR = ((1<<TWINT)|(1<<TWEN)|(1<<TWEA));      //Clear int flag to send byte
//	 TWCR = 0xE4;
  i2c_delay();             //Wait for TWI interrupt flag set
  if((TWSR != MTX_ADR_ACK)&&(TWSR != MRX_ADR_ACK))//If NACK received return
    i2c_error=1;
}


// ,  last_byte=0,          
unsigned char i2c_rx(unsigned char last_byte)
{
//  if(i2c_error)  return 0;
  
  i2c_delay();
  if(last_byte)                                       //    , 
    TWCR = ((1<<TWINT)|(1<<TWEN)|(1<<TWEA));          //  
  else
    TWCR=((1<<TWINT)|(1<<TWEN));                      // - 
  i2c_delay();
  if(((TWSR != MRX_DATA_NACK)&&(last_byte == NOT_ACK))&&(TWSR != MRX_DATA_ACK))
    i2c_error=1;
  return TWDR;
}

//
static void i2c_delay(void)
{
//  if(i2c_error) return;
  for(unsigned int i=0;i<100;i++)
    {
      if(TWCR&(1<<TWINT)) return;
	  
      __delay_cycles(0.000001*F_CLK);
    }
  i2c_error=1;
}



