/*******************************************************************************************
*         TWI                      *
                                                       *
*******************************************************************************************/

#ifndef I2C_H
#define I2C_H

#include "Defines.h"

#include <ioavr.h>
#include <intrinsics.h>
//#include	<iousb1287.h>
//#include <Types.h>


//#define F_CLK 8000000


/* 2-wire SI */
#define  TWINT    7
#define  TWEA     6
#define  TWSTA    5
#define  TWSTO    4
#define  TWWC     3
#define  TWEN     2
#define  TWIE     0

#define TWI_TWBR (0x1C)				// 100 KHz with 8 MHz quartz
// #define TWI_TWBR 20                                  //  

#define WR                0                           // 
#define RD                1                           // 

#define SDA1_LN            1                           // SDA
#define SDA2_LN            2                           // SDA
#define SDA3_LN            3                           // SDA
#define SDA4_LN            4                           // SDA
//#define SDA_LN           ((1<<SDA1_LN)|(1<<SDA2_LN)|(1<<SDA3_LN)|(1<<SDA4_LN))
#define SCL_LN            0                           // SCL
#define I2C_PIN           PINA                        // 
#define I2C_DDR           DDRA                        // 
#define I2C_PORT          PORTA                       // 

#define IN_LN             0                           //  
#define OUT_LN            1                           //  

#define ACK               1                           //   (  )
#define NOT_ACK           0                           //   ( )

#define I2C_T             0.00001                     //   (1/I2C_T =  )
                                                      //   

// 
// 
void i2c_init_soft(void);
void i2c_start_soft(void);
void i2c_stop_soft(void);
void i2c_tx_soft(unsigned char byte);
unsigned char i2c_rx_soft(unsigned char last_byte);

unsigned char i2c_rx(unsigned char last_byte);
unsigned char in_sda(unsigned char num);
void sda_io(unsigned char io_c);
void scl_set(unsigned char set_c);
void sda_set(unsigned char set_c);


void i2c_init(unsigned char my_addr);
void i2c_start(void);
void i2c_stop(void);
void i2c_tx(unsigned char byte);
void i2c_tx_addr(unsigned char adr, unsigned char rw);
unsigned char i2c_rx(unsigned char last_byte);
static void i2c_delay(void);

//General Master staus codes
#define START             0x08                        //START has been transmitted
#define REP_START         0x10                        //Repeated START has been
                                                      //transmitted
//Master Transmitter staus codes
#define MTX_ADR_ACK       0x18                        //SLA+W has been tramsmitted
                                                      //and ACK received
#define MTX_ADR_NACK      0x20                        //SLA+W has been tramsmitted
                                                      //and NACK received
#define MTX_DATA_ACK      0x28                        //Data byte has been tramsmitted
                                                      //and ACK received
#define MTX_DATA_NACK     0x30                        //Data byte has been tramsmitted
                                                      //and NACK received
#define MTX_ARB_LOST      0x38                        //Arbitration lost in SLA+W or
                                                      //data bytes
//Master Receiver staus codes
#define MRX_ARB_LOST      0x38                        //Arbitration lost in SLA+R or
                                                      //NACK bit
#define MRX_ADR_ACK       0x40                        //SLA+R has been tramsmitted
                                                      //and ACK received
#define MRX_ADR_NACK      0x48                        //SLA+R has been tramsmitted
                                                      //and NACK received
#define MRX_DATA_ACK      0x50                        //Data byte has been received
                                                      //and ACK tramsmitted
#define MRX_DATA_NACK     0x58                        //Data byte has been received
                                                      //and NACK tramsmitted

// TWI Slave Receiver staus codes
#define TWI_SRX_ADR_ACK            0x60  // Own SLA+W has been received ACK has been returned
#define TWI_SRX_ADR_ACK_M_ARB_LOST 0x68  // Arbitration lost in SLA+R/W as Master; own SLA+W has been received; ACK has been returned
#define TWI_SRX_GEN_ACK            0x70  // General call address has been received; ACK has been returned
#define TWI_SRX_GEN_ACK_M_ARB_LOST 0x78  // Arbitration lost in SLA+R/W as Master; General call address has been received; ACK has been returned
#define TWI_SRX_ADR_DATA_ACK       0x80  // Previously addressed with own SLA+W; data has been received; ACK has been returned
#define TWI_SRX_ADR_DATA_NACK      0x88  // Previously addressed with own SLA+W; data has been received; NOT ACK has been returned
#define TWI_SRX_GEN_DATA_ACK       0x90  // Previously addressed with general call; data has been received; ACK has been returned
#define TWI_SRX_GEN_DATA_NACK      0x98  // Previously addressed with general call; data has been received; NOT ACK has been returned
#define TWI_SRX_STOP_RESTART       0xA0  // A STOP condition or repeated START condition has been received while still addressed as Slave



        #define		I2CPORT				PORTD
	#define		I2CDDR			  	DDRD
	#define		I2CPINS				(PIND)
	#define		I2CCLOCK		  	0
	#define		I2CDATA			  	1


#endif


